Subject: Re: [forces] New Non-WG Mailing List: irs-discuss -- Interface to The Internet Routing System (IRS)

From: Stephane Bortzmeyer <[email-masked]>
Date: Fri, 24 Aug 2012 18:05:40 +0200

On Thu, Jul 26, 2012 at 05:45:29PM -0700,
 IETF Secretariat <[email-masked]> wrote 
 a message of 34 lines which said:

> A new IETF non-working group email list has been created.
> 
> List address: [email-masked]
> Archive: http://www.ietf.org/mail-archive/web/irs-discuss/
> To subscribe: https://www.ietf.org/mailman/listinfo/irs-discuss

It really looks like very close from what the Forces working group
have been doing. Can anyone explain why we need to start a new
project?

---

From: Benson Schliesser <[email-masked]>
Date: Fri, 24 Aug 2012 11:24:12 -0500

Hi, Stephane.

> have been doing. Can anyone explain why we need to start a new

At a high level, I think there is a different assumption about where the 
control-plane resides. In IRS the forwarding and control planes might be 
co-resident in the router (i.e. not "separated"), and the IRS protocol 
would be a way of extending limited control over routing state to 
external applications.

If I understand ForCES correctly (which is possibly not the case) then I 
imagine it could be used in a similar architecture and/or as a protocol 
layer for IRS. But the first step in the context of IRS is to make a 
problem statement, understand requirements, etc.

Others might have more intelligent comments, which I welcome. :) But 
please let me know if this perspective helps clarify things, and/or if 
I'm missing some ideas that I should understand better, etc.

Cheers,
-Benson

---

From: Jamal Hadi Salim <[email-masked]>
Date: Mon, 27 Aug 2012 07:23:25 -0400

On Fri, Aug 24, 2012 at 12:24 PM, Benson Schliesser
<[email-masked]> wrote:

> control-plane resides.

Clarification on the generic statement above below.

>In IRS the forwarding and control planes might be
> co-resident in the router (i.e. not "separated"), and the IRS protocol would
> be a way of extending limited control over routing state to external
> applications.
>
> layer for IRS. But the first step in the context of IRS is to make a problem
> statement, understand requirements, etc.
>

Indeed. Once clarity sets in on the requirements, ForCES may or may not be a
good choice.

Where i feel obligated to respond is to the comment on your first part.
It boxes ForCES into only being useful in a southbound control-datapath
separation.  We've used it to control a bunch of ethernet switches which have
co-resident  control/data plane from the vendor. We've used it to configure
things that are not packet processing entities - consider this presentation
https://www.ietf.org/proceedings/84/slides/slides-84-forces-2.pdf
which illustrates how we model a configuration file (nothing to do with a
datapath functional block) into an LFB and then proceed to query/set
from the CE.

cheers,
jamal

---

From: Susan Hares <[email-masked]>
Date: Mon, 27 Aug 2012 11:22:48 +0000

Benson:

Forces is looking between the control plane and the data forwarding plane. The IRS work is focused on contacting between a control program and the routing process on the routing control plane.

X central controller 
(IRS Commissioner) 
  | 
 IRS client  (Control Plane (CP) - routing process) 
 [routing processes]
 CP - 
  ----
  Forces CE 
    |
  Forces FE     

Sue Hares 

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Benson Schliesser
Sent: Friday, August 24, 2012 9:24 AM
To: Stephane Bortzmeyer
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [irs-discuss] [forces] New Non-WG Mailing List: irs-discuss -- Interface to The Internet Routing System (IRS)

Hi, Stephane.

Cheers,
-Benson

_______________________________________________
irs-discuss mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/irs-discuss

---

From: Jamal Hadi Salim <[email-masked]>
Date: Mon, 27 Aug 2012 07:42:28 -0400

With apologies to Alia, I feel obligated to feed this discussion ;->

On Mon, Aug 27, 2012 at 7:22 AM, Susan Hares <[email-masked]> wrote:
> Benson:
>
> Forces is looking between the control plane and the data forwarding plane.
>The IRS work is focused on contacting between a control program and the routing process on the routing >control plane.
>

In my view:
IRS may provide an API or abstraction that looks like a routing sockets or
netlink_route (refer to section 3.1 and 3.2 of RFC 3549), underneath
the implementation maybe indeed ForCES.

cheers,
jamal

---

From: Jamal Hadi Salim <[email-masked]>
Date: Mon, 27 Aug 2012 08:39:28 -0400

Hi Sue,

On Mon, Aug 27, 2012 at 8:00 AM, Susan Hares <[email-masked]> wrote:
> Jamal:
>
> Can you give an example of how IRS and Forces might interact via this route
> socket?
> Due to the wide background on the lists (irs & forces) , it would be good to
> give an example within a switch or router as context.

Just the example i posted from the RFC which demonstrates access to a FIB
and nexthop tables. All of that can be delivered with ForCES (given netlink
was an input in ForCES design).
The semantics to a RIB as opposed to a FIB are different.  Example, the
credentials are weaker on the FIB aspects (the "protocol" field in the
route message). But all that is a model issue i.e ForCES is agnostic
of the description.

I know you are a guru in this area - so hoping to get some wisdom.
Sorry for dragging this discussion into this direction.

cheers,
jamal

---

From: "Susan Hares" <[email-masked]>
Date: Mon, 27 Aug 2012 08:00:08 -0400

Jamal:

Sue 

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of Jamal Hadi Salim
Sent: Monday, August 27, 2012 7:42 AM
To: Susan Hares
Cc: Benson Schliesser; [email-masked]; Stephane Bortzmeyer;
[email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [irs-discuss] [forces] New Non-WG Mailing List: irs-discuss --
Interface to The Internet Routing System (IRS)

On Mon, Aug 27, 2012 at 7:22 AM, Susan Hares <[email-masked]> wrote:
>The IRS work is focused on contacting between a control program and the
routing process on the routing >control plane.

In my view:
IRS may provide an API or abstraction that looks like a routing sockets or
netlink_route (refer to section 3.1 and 3.2 of RFC 3549), underneath the
implementation maybe indeed ForCES.

cheers,
jamal

---

From: "Dutta, Pranjal K (Pranjal)" <[email-masked]>
Date: Thu, 30 Aug 2012 01:16:45 +0530

I am not quite sure about this. We find the problem statement of IRS as follows:

<>
   In order to enable applications to have access to and control over
   information in the Internet's routing system, we need a publically
   documented interface specification.  The interface needs to support
   real-time, transaction-based interactions using efficient data models
   and encodings.  Furthermore, the interface must support a variety of
   use cases including those where verified control feed-back loops are
   needed. </>

The way I understand, it's about building flexible/programmable 
abstractions into Routing Systems - It's not necessary that entire control plane is taken away. So I don't see the framework as complete separation 
of control plane and data plane.

The IRS frame work further highlights Bidirectional Interfaces to the Routing System.

Thanks,
Pranjal